diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mobility/model/geocentric-constant-position-mobility-model.cc ns-3.42/src/mobility/model/geocentric-constant-position-mobility-model.cc
--- ns-3.41/src/mobility/model/geocentric-constant-position-mobility-model.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.42/src/mobility/model/geocentric-constant-position-mobility-model.cc	2024-05-29 15:29:47.136073600 -0700
@@ -0,0 +1,247 @@
+/*
+ * Copyright (c) 2006,2007 INRIA
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Mattia Sandri <mattia.sandri@unipd.it>
+ */
+#include "geocentric-constant-position-mobility-model.h"
+
+#include <ns3/angles.h>
+
+#include <math.h>
+
+/**
+ *  \file
+ *  \ingroup mobility
+ *  Class GeocentricConstantPositionMobilityModel implementation.
+ */
+
+namespace ns3
+{
+
+NS_OBJECT_ENSURE_REGISTERED(GeocentricConstantPositionMobilityModel);
+
+TypeId
+GeocentricConstantPositionMobilityModel::GetTypeId()
+{
+    static TypeId tid =
+        TypeId("ns3::GeocentricConstantPositionMobilityModel")
+            .SetParent<MobilityModel>()
+            .SetGroupName("Mobility")
+            .AddConstructor<GeocentricConstantPositionMobilityModel>()
+            .AddAttribute(
+                "PositionLatLongAlt",
+                "The geographic position, in degrees (lat/lon) and meter (alt), in the order: "
+                "latitude, longitude and "
+                "altitude",
+                Vector3DValue({0, 0, 0}),
+                MakeVector3DAccessor(&GeocentricConstantPositionMobilityModel::m_position),
+                MakeVector3DChecker())
+            .AddAttribute("GeographicReferencePoint",
+                          "The point, in meters, taken as reference when converting from "
+                          "geographic to topographic.",
+                          Vector3DValue({0, 0, 0}),
+                          MakeVector3DAccessor(
+                              &GeocentricConstantPositionMobilityModel::m_geographicReferencePoint),
+                          MakeVector3DChecker());
+    return tid;
+}
+
+Vector
+GeocentricConstantPositionMobilityModel::GetGeographicPosition() const
+{
+    return DoGetGeographicPosition();
+}
+
+void
+GeocentricConstantPositionMobilityModel::SetGeographicPosition(const Vector& latLonAlt)
+{
+    DoSetGeographicPosition(latLonAlt);
+}
+
+Vector
+GeocentricConstantPositionMobilityModel::GetGeocentricPosition() const
+{
+    return DoGetGeocentricPosition();
+}
+
+void
+GeocentricConstantPositionMobilityModel::SetGeocentricPosition(const Vector& position)
+{
+    DoSetGeocentricPosition(position);
+}
+
+double
+GeocentricConstantPositionMobilityModel::GetElevationAngle(
+    Ptr<const GeocentricConstantPositionMobilityModel> other)
+{
+    return DoGetElevationAngle(other);
+}
+
+void
+GeocentricConstantPositionMobilityModel::SetCoordinateTranslationReferencePoint(
+    const Vector& position)
+{
+    DoSetCoordinateTranslationReferencePoint(position);
+}
+
+Vector
+GeocentricConstantPositionMobilityModel::GetCoordinateTranslationReferencePoint() const
+{
+    return DoGetCoordinateTranslationReferencePoint();
+}
+
+Vector
+GeocentricConstantPositionMobilityModel::GetPosition() const
+{
+    return DoGetPosition();
+}
+
+void
+GeocentricConstantPositionMobilityModel::SetPosition(const Vector& position)
+{
+    return DoSetPosition(position);
+}
+
+double
+GeocentricConstantPositionMobilityModel::GetDistanceFrom(
+    Ptr<const GeocentricConstantPositionMobilityModel> other) const
+{
+    return DoGetDistanceFrom(other);
+}
+
+Vector
+GeocentricConstantPositionMobilityModel::DoGetPosition() const
+{
+    Vector topographicCoordinates =
+        GeographicPositions::GeographicToTopocentricCoordinates(m_position,
+                                                                m_geographicReferencePoint,
+                                                                GeographicPositions::SPHERE);
+    return topographicCoordinates;
+}
+
+void
+GeocentricConstantPositionMobilityModel::DoSetPosition(const Vector& position)
+{
+    Vector geographicCoordinates =
+        GeographicPositions::TopocentricToGeographicCoordinates(position,
+                                                                m_geographicReferencePoint,
+                                                                GeographicPositions::SPHERE);
+    m_position = geographicCoordinates;
+    NotifyCourseChange();
+}
+
+double
+GeocentricConstantPositionMobilityModel::DoGetDistanceFrom(
+    Ptr<const GeocentricConstantPositionMobilityModel> other) const
+{
+    Vector cartesianCoordA =
+        GeographicPositions::GeographicToCartesianCoordinates(m_position.x,
+                                                              m_position.y,
+                                                              m_position.z,
+                                                              GeographicPositions::SPHERE);
+    Vector cartesianCoordB = other->DoGetGeocentricPosition();
+
+    double distance = (cartesianCoordA - cartesianCoordB).GetLength();
+
+    return distance;
+}
+
+Vector
+GeocentricConstantPositionMobilityModel::DoGetGeographicPosition() const
+{
+    return m_position;
+}
+
+void
+GeocentricConstantPositionMobilityModel::DoSetGeographicPosition(const Vector& latLonAlt)
+{
+    NS_ASSERT_MSG((latLonAlt.x >= -90) && (latLonAlt.x <= 90),
+                  "Latitude must be between -90 deg and +90 deg");
+    NS_ASSERT_MSG(latLonAlt.z >= 0, "Altitude must be higher or equal than 0 meters");
+
+    m_position = latLonAlt;
+    // Normalize longitude to [-180, 180]
+    m_position.y = WrapTo180(m_position.y);
+    NotifyCourseChange();
+}
+
+Vector
+GeocentricConstantPositionMobilityModel::DoGetGeocentricPosition() const
+{
+    Vector geocentricCoordinates =
+        GeographicPositions::GeographicToCartesianCoordinates(m_position.x,
+                                                              m_position.y,
+                                                              m_position.z,
+                                                              GeographicPositions::SPHERE);
+    return geocentricCoordinates;
+}
+
+void
+GeocentricConstantPositionMobilityModel::DoSetGeocentricPosition(const Vector& position)
+{
+    Vector geographicCoordinates =
+        GeographicPositions::CartesianToGeographicCoordinates(position,
+                                                              GeographicPositions::SPHERE);
+    m_position = geographicCoordinates;
+    NotifyCourseChange();
+}
+
+double
+GeocentricConstantPositionMobilityModel::DoGetElevationAngle(
+    Ptr<const GeocentricConstantPositionMobilityModel> other)
+{
+    Vector me = this->DoGetGeocentricPosition();
+    Vector them = other->DoGetGeocentricPosition();
+
+    // a is assumed to be the terminal with the lowest altitude
+    Vector& a = (me.z < them.z ? me : them);
+    Vector& b = (me.z < them.z ? them : me);
+
+    Vector bMinusA = b - a;
+    double numerator = std::abs(a * bMinusA);
+    double denominator = a.GetLength() * bMinusA.GetLength();
+    double x = numerator / denominator;
+
+    // Enforce the appropriate domain range ([-1, 1]) for the argument of std::asin.
+    x = std::min(x, 1.0);
+    x = std::max(x, -1.0);
+
+    // asin returns radians, we convert to degrees
+    double elevAngle = abs((180.0 * M_1_PI) * asin(x));
+
+    return elevAngle;
+}
+
+void
+GeocentricConstantPositionMobilityModel::DoSetCoordinateTranslationReferencePoint(
+    const Vector& refPoint)
+{
+    m_geographicReferencePoint = refPoint;
+}
+
+Vector
+GeocentricConstantPositionMobilityModel::DoGetCoordinateTranslationReferencePoint() const
+{
+    return m_geographicReferencePoint;
+}
+
+Vector
+GeocentricConstantPositionMobilityModel::DoGetVelocity() const
+{
+    return Vector(0.0, 0.0, 0.0);
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mobility/model/geocentric-constant-position-mobility-model.h ns-3.42/src/mobility/model/geocentric-constant-position-mobility-model.h
--- ns-3.41/src/mobility/model/geocentric-constant-position-mobility-model.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.42/src/mobility/model/geocentric-constant-position-mobility-model.h	2024-05-29 15:29:47.136073600 -0700
@@ -0,0 +1,162 @@
+/*
+ * Copyright (c) 2006,2007 INRIA
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Mattia Sandri <mattia.sandri@unipd.it>
+ */
+#ifndef GEOCENTRIC_CONSTANT_POSITION_MOBILITY_MODEL_H
+#define GEOCENTRIC_CONSTANT_POSITION_MOBILITY_MODEL_H
+
+#include "geographic-positions.h"
+#include "mobility-model.h"
+
+/**
+ * \file
+ * \ingroup mobility
+ * Class GeocentricConstantPositionMobilityModel declaration.
+ */
+
+namespace ns3
+{
+
+/**
+ * \brief Mobility model using geocentric euclidean coordinates, as defined in 38.811 chapter 6.3
+ */
+class GeocentricConstantPositionMobilityModel : public MobilityModel
+{
+  public:
+    /**
+     * Register this type with the TypeId system.
+     * \return the object TypeId
+     */
+    static TypeId GetTypeId();
+    /**
+     * Create a position located at coordinates (0,0,0)
+     */
+    GeocentricConstantPositionMobilityModel() = default;
+    ~GeocentricConstantPositionMobilityModel() override = default;
+
+    /**
+     * \brief Computes elevation angle between a ground terminal and a HAPS/Satellite.
+     * After calculating the plane perpendicular to a cartesian position vector,
+     * the elevation angle is calculated using
+     * https://www.w3schools.blog/angle-between-a-line-and-a-plane.
+     * The altitude of the position passed as a parameter must be higher than that of the reference
+     * point.
+     * \param other pointer to the HAPS/satellite mobility model
+     * \return the elevation angle
+     * in degrees
+     */
+    virtual double GetElevationAngle(Ptr<const GeocentricConstantPositionMobilityModel> other);
+
+    /**
+     * \brief Get the position using geographic (geodetic) coordinates
+     * \return Vector containing (latitude (degree), longitude (degree), altitude (meter))
+     */
+    virtual Vector GetGeographicPosition() const;
+
+    /**
+     * \brief Set the position using geographic coordinates
+     *
+     * Sets the position, using geographic coordinates and asserting
+     * that the provided parameter falls within the appropriate range.
+     *
+     * \param latLonAlt pointer to a Vector containing (latitude (degree), longitude (degree),
+     * altitude (meter)). The values are expected to be in the ranges [-90, 90], [-180, 180], [0,
+     * +inf[, respectively. These assumptions are enforced with an assert for the latitude and the
+     * altitude, while the longitude is normalized to the expected range.
+     */
+    virtual void SetGeographicPosition(const Vector& latLonAlt);
+
+    /**
+     * \brief Get the position using Geocentric Cartesian coordinates
+     * \return Vector containing (x, y, z) (meter) coordinates
+     */
+    virtual Vector GetGeocentricPosition() const;
+
+    /**
+     * \brief Set the position using Geocentric Cartesian coordinates
+     * \param position pointer to a Vector containing (x, y, z) (meter) coordinates
+     */
+    virtual void SetGeocentricPosition(const Vector& position);
+
+    /**
+     * \brief Set the reference point for coordinate conversion
+     * \param refPoint vector containing the geographic reference point (meter)
+     */
+    virtual void SetCoordinateTranslationReferencePoint(const Vector& refPoint);
+
+    /**
+     * \brief Get the reference point for coordinate conversion
+     * \return Vector containing geographic reference point (meter)
+     */
+    virtual Vector GetCoordinateTranslationReferencePoint() const;
+
+    /**
+     * \return the current position
+     */
+    virtual Vector GetPosition() const;
+
+    /**
+     * \param position the position to set.
+     */
+    virtual void SetPosition(const Vector& position);
+
+    /**
+     * \param other a reference to another mobility model
+     * \return the distance between the two objects. Unit is meters.
+     */
+    double GetDistanceFrom(Ptr<const GeocentricConstantPositionMobilityModel> other) const;
+
+  private:
+    /** \copydoc GetPosition() */
+    Vector DoGetPosition() const override;
+    /** \copydoc SetPosition() */
+    void DoSetPosition(const Vector& position) override;
+    /** \copydoc GetVelocity() */
+    Vector DoGetVelocity() const override;
+    /** \copydoc GetDistanceFrom() */
+    double DoGetDistanceFrom(Ptr<const GeocentricConstantPositionMobilityModel> other) const;
+    /** \copydoc GetGeographicPosition() */
+    virtual Vector DoGetGeographicPosition() const;
+    /** \copydoc SetGeographicPosition() */
+    virtual void DoSetGeographicPosition(const Vector& latLonAlt);
+    /** \copydoc GetGeocentricPosition() */
+    virtual Vector DoGetGeocentricPosition() const;
+    /** \copydoc SetGeocentricPosition() */
+    virtual void DoSetGeocentricPosition(const Vector& position);
+    /** \copydoc GetElevationAngle() */
+    virtual double DoGetElevationAngle(Ptr<const GeocentricConstantPositionMobilityModel> other);
+    /** \copydoc SetCoordinateTranslationReferencePoint() */
+    virtual void DoSetCoordinateTranslationReferencePoint(const Vector& refPoint);
+    /** \copydoc GetCoordinateTranslationReferencePoint() */
+    virtual Vector DoGetCoordinateTranslationReferencePoint() const;
+
+    /**
+     * the constant Geographic position,, in order: latitude (degree), longitude (degree), altitude
+     * (meter).
+     */
+    Vector m_position{0, 0, 0};
+
+    /**
+     * This is the point (meter) taken as a reference for converting
+     * from geographic to topographic (also referred to as planar Cartesian)
+     */
+    Vector m_geographicReferencePoint{0, 0, 0};
+};
+
+} // namespace ns3
+
+#endif /* GEOCENTRIC_CONSTANT_POSITION_MOBILITY_MODEL_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/mobility/model/geographic-positions.cc ns-3.42/src/mobility/model/geographic-positions.cc
--- ns-3.41/src/mobility/model/geographic-positions.cc	2024-02-09 14:44:08.365793500 -0800
+++ ns-3.42/src/mobility/model/geographic-positions.cc	2024-05-29 15:29:47.136073600 -0700
@@ -19,18 +19,15 @@
 
 #include "geographic-positions.h"
 
+#include <ns3/angles.h>
 #include <ns3/log.h>
 
 #include <cmath>
 
 NS_LOG_COMPONENT_DEFINE("GeographicPositions");
 
-namespace ns3
+namespace
 {
-
-/// Earth's radius in meters if modeled as a perfect sphere
-static constexpr double EARTH_RADIUS = 6371e3;
-
 /**
  * GRS80 and WGS84 sources
  *
@@ -42,20 +39,14 @@
  * <https://web.archive.org/web/20200730231853/http://earth-info.nga.mil/GandG/publications/tr8350.2/wgs84fin.pdf>.
  */
 
-/// Earth's semi-major axis in meters as defined by both GRS80 and WGS84
-static constexpr double EARTH_SEMIMAJOR_AXIS = 6378137;
-
-/// Earth's first eccentricity as defined by GRS80
-static constexpr double EARTH_GRS80_ECCENTRICITY = 0.0818191910428158;
-
-/// Earth's first eccentricity as defined by WGS84
-static constexpr double EARTH_WGS84_ECCENTRICITY = 0.0818191908426215;
-
-/// Conversion factor: degrees to radians
-static constexpr double DEG2RAD = M_PI / 180.0;
+/**
+ * \brief  Lambda function for computing the curvature
+ */
+auto curvature = [](double e, double ph) { return sqrt(1 - e * e * sin(ph) * sin(ph)); };
+} // namespace
 
-/// Conversion factor: radians to degrees
-static constexpr double RAD2DEG = 180.0 * M_1_PI;
+namespace ns3
+{
 
 Vector
 GeographicPositions::GeographicToCartesianCoordinates(double latitude,
@@ -64,31 +55,16 @@
                                                       EarthSpheroidType sphType)
 {
     NS_LOG_FUNCTION_NOARGS();
-    double latitudeRadians = DEG2RAD * latitude;
-    double longitudeRadians = DEG2RAD * longitude;
-    double a; // semi-major axis of earth
-    double e; // first eccentricity of earth
-    if (sphType == SPHERE)
-    {
-        a = EARTH_RADIUS;
-        e = 0;
-    }
-    else if (sphType == GRS80)
-    {
-        a = EARTH_SEMIMAJOR_AXIS;
-        e = EARTH_GRS80_ECCENTRICITY;
-    }
-    else // if sphType == WGS84
-    {
-        a = EARTH_SEMIMAJOR_AXIS;
-        e = EARTH_WGS84_ECCENTRICITY;
-    }
+    double latitudeRadians = DegreesToRadians(latitude);
+    double longitudeRadians = DegreesToRadians(longitude);
+
+    // Retrieve radius, first eccentricity and flattening according to the specified Earth's model
+    auto [a, e, f] = GetRadiusEccentFlat(sphType);
 
-    double Rn = a / (sqrt(1 - pow(e, 2) * pow(sin(latitudeRadians), 2))); // radius of
-                                                                          // curvature
+    double Rn = a / curvature(e, latitudeRadians); // radius of curvature
     double x = (Rn + altitude) * cos(latitudeRadians) * cos(longitudeRadians);
     double y = (Rn + altitude) * cos(latitudeRadians) * sin(longitudeRadians);
-    double z = ((1 - pow(e, 2)) * Rn + altitude) * sin(latitudeRadians);
+    double z = ((1 - e * e) * Rn + altitude) * sin(latitudeRadians);
     Vector cartesianCoordinates = Vector(x, y, z);
     return cartesianCoordinates;
 }
@@ -98,23 +74,8 @@
 {
     NS_LOG_FUNCTION(pos << sphType);
 
-    double a; // semi-major axis of earth
-    double e; // first eccentricity of earth
-    if (sphType == SPHERE)
-    {
-        a = EARTH_RADIUS;
-        e = 0;
-    }
-    else if (sphType == GRS80)
-    {
-        a = EARTH_SEMIMAJOR_AXIS;
-        e = EARTH_GRS80_ECCENTRICITY;
-    }
-    else // if sphType == WGS84
-    {
-        a = EARTH_SEMIMAJOR_AXIS;
-        e = EARTH_WGS84_ECCENTRICITY;
-    }
+    // Retrieve radius, first eccentricity and flattening according to the specified Earth's model
+    auto [a, e, f] = GetRadiusEccentFlat(sphType);
 
     Vector lla;
     Vector tmp;
@@ -134,10 +95,10 @@
         lla.x = atan2(pos.z, p * (1 - e2 * N / v));
     }
     // 1 m difference is approx 1 / 30 arc seconds = 9.26e-6 deg
-    while (fabs(lla.x - tmp.x) > 0.00000926 * DEG2RAD);
+    while (fabs(lla.x - tmp.x) > DegreesToRadians(0.00000926));
 
-    lla.x *= RAD2DEG;
-    lla.y *= RAD2DEG;
+    lla.x = RadiansToDegrees(lla.x);
+    lla.y = RadiansToDegrees(lla.y);
 
     // canonicalize (latitude) x in [-90, 90] and (longitude) y in [-180, 180)
     if (lla.x > 90.0)
@@ -165,6 +126,84 @@
     return lla;
 }
 
+Vector
+GeographicPositions::GeographicToTopocentricCoordinates(Vector pos,
+                                                        Vector refPoint,
+                                                        EarthSpheroidType sphType)
+{
+    NS_LOG_FUNCTION(pos << sphType);
+
+    double phi = DegreesToRadians(pos.x);
+    double lambda = DegreesToRadians(pos.y);
+    double h = pos.z;
+    double phi0 = DegreesToRadians(refPoint.x);
+    double lambda0 = DegreesToRadians(refPoint.y);
+    double h0 = refPoint.z;
+    // Retrieve radius, first eccentricity and flattening according to the specified Earth's model
+    auto [a, e, f] = GetRadiusEccentFlat(sphType);
+
+    // the radius of curvature in the prime vertical at latitude
+    double v = a / curvature(e, phi);
+    // the radius of curvature in the prime vertical at latitude
+    // of the reference point
+    double v0 = a / curvature(e, phi0);
+
+    double U = (v + h) * cos(phi) * sin(lambda - lambda0);
+    double V = (v + h) * (sin(phi) * cos(phi0) - cos(phi) * sin(phi0) * cos(lambda - lambda0)) +
+               e * e * (v0 * sin(phi0) - v * sin(phi)) * cos(phi0);
+    double W = (v + h) * (sin(phi) * sin(phi0) + cos(phi) * cos(phi0) * cos(lambda - lambda0)) +
+               e * e * (v0 * sin(phi0) - v * sin(phi)) * sin(phi0) - (v0 + h0);
+
+    Vector topocentricCoordinates = Vector(U, V, W);
+    return topocentricCoordinates;
+}
+
+Vector
+GeographicPositions::TopocentricToGeographicCoordinates(Vector pos,
+                                                        Vector refPoint,
+                                                        EarthSpheroidType sphType)
+{
+    NS_LOG_FUNCTION(pos << sphType);
+
+    double U = pos.x;
+    double V = pos.y;
+    double W = pos.z;
+    double phi0 = DegreesToRadians(refPoint.x);
+    double lambda0 = DegreesToRadians(refPoint.y);
+    double h0 = refPoint.z;
+    // Retrieve radius, first eccentricity and flattening according to the specified Earth's model
+    auto [a, e, f] = GetRadiusEccentFlat(sphType);
+
+    // the radius of curvature in the prime vertical at latitude
+    // of the reference point
+    double v0 = a / curvature(e, phi0);
+
+    double X0 = (v0 + h0) * cos(phi0) * cos(lambda0);
+    double Y0 = (v0 + h0) * cos(phi0) * sin(lambda0);
+    double Z0 = ((1 - e * e) * v0 + h0) * sin(phi0);
+
+    double X = X0 - U * sin(lambda0) - V * sin(phi0) * cos(lambda0) + W * cos(phi0) * cos(lambda0);
+    double Y = Y0 + U * cos(lambda0) - V * sin(phi0) * sin(lambda0) + W * cos(phi0) * sin(lambda0);
+    double Z = Z0 + V * cos(phi0) + W * sin(phi0);
+
+    double epsilon = e * e / (1 - e * e);
+    double b = a * (1 - f);
+    double p = sqrt(X * X + Y * Y);
+    double q = atan2((Z * a), (p * b));
+
+    double phi = atan2((Z + epsilon * b * pow(sin(q), 3)), (p - e * e * a * pow(cos(q), 3)));
+    double lambda = atan2(Y, X);
+
+    double v = a / curvature(e, phi);
+    double h = (p / cos(phi)) - v;
+
+    phi = RadiansToDegrees(phi);
+    lambda = RadiansToDegrees(lambda);
+
+    Vector geographicCoordinates = Vector(phi, lambda, h);
+    return geographicCoordinates;
+}
+
 std::list<Vector>
 GeographicPositions::RandCartesianPointsAroundGeographicPoint(double originLatitude,
                                                               double originLongitude,
@@ -194,27 +233,28 @@
         maxAltitude = 0;
     }
 
-    double originLatitudeRadians = originLatitude * DEG2RAD;
-    double originLongitudeRadians = originLongitude * DEG2RAD;
+    double originLatitudeRadians = DegreesToRadians(originLatitude);
+    double originLongitudeRadians = DegreesToRadians(originLongitude);
     double originColatitude = (M_PI_2)-originLatitudeRadians;
 
-    double a = maxDistFromOrigin / EARTH_RADIUS; // maximum alpha allowed
-                                                 // (arc length formula)
+    // maximum alpha allowed (arc length formula)
+    double a = maxDistFromOrigin / EARTH_SPHERE_RADIUS;
     if (a > M_PI)
     {
-        a = M_PI; // pi is largest alpha possible (polar angle from origin that
-                  // points can be generated within)
+        // pi is largest alpha possible (polar angle from origin that
+        // points can be generated within)
+        a = M_PI;
     }
 
     std::list<Vector> generatedPoints;
     for (int i = 0; i < numPoints; i++)
     {
         // random distance from North Pole (towards center of earth)
-        double d = uniRand->GetValue(0, EARTH_RADIUS - EARTH_RADIUS * cos(a));
+        double d = uniRand->GetValue(0, EARTH_SPHERE_RADIUS - EARTH_SPHERE_RADIUS * cos(a));
         // random angle in latitude slice (wrt Prime Meridian), radians
         double phi = uniRand->GetValue(0, M_PI * 2);
         // random angle from Center of Earth (wrt North Pole), radians
-        double alpha = acos((EARTH_RADIUS - d) / EARTH_RADIUS);
+        double alpha = acos((EARTH_SPHERE_RADIUS - d) / EARTH_SPHERE_RADIUS);
 
         // shift coordinate system from North Pole referred to origin point referred
         // reference: http://en.wikibooks.org/wiki/General_Astronomy/Coordinate_Systems
@@ -242,18 +282,48 @@
         // random altitude above earth's surface
         double randAltitude = uniRand->GetValue(0, maxAltitude);
 
-        Vector pointPosition =
-            GeographicPositions::GeographicToCartesianCoordinates(randPointLatitude * RAD2DEG,
-                                                                  randPointLongitude * RAD2DEG,
-                                                                  randAltitude,
-                                                                  SPHERE);
-        // convert coordinates
-        // from geographic to cartesian
+        // convert coordinates from geographic to cartesian
+        Vector pointPosition = GeographicPositions::GeographicToCartesianCoordinates(
+            RadiansToDegrees(randPointLatitude),
+            RadiansToDegrees(randPointLongitude),
+            randAltitude,
+            SPHERE);
 
-        generatedPoints.push_back(pointPosition); // add generated coordinate
-                                                  // points to list
+        // add generated coordinate points to list
+        generatedPoints.push_back(pointPosition);
     }
     return generatedPoints;
 }
 
+std::tuple<double, double, double>
+GeographicPositions::GetRadiusEccentFlat(EarthSpheroidType type)
+{
+    double a; // radius, in meters
+    double e; // first eccentricity
+    double f; // first flattening
+
+    switch (type)
+    {
+    case SPHERE:
+        a = EARTH_SPHERE_RADIUS;
+        e = EARTH_SPHERE_ECCENTRICITY;
+        f = EARTH_SPHERE_FLATTENING;
+        break;
+    case GRS80:
+        a = EARTH_SEMIMAJOR_AXIS;
+        e = EARTH_GRS80_ECCENTRICITY;
+        f = EARTH_GRS80_FLATTENING;
+        break;
+    case WGS84:
+        a = EARTH_SEMIMAJOR_AXIS;
+        e = EARTH_WGS84_ECCENTRICITY;
+        f = EARTH_WGS84_FLATTENING;
+        break;
+    default:
+        NS_FATAL_ERROR("The specified earth model is not supported!");
+    }
+
+    return std::make_tuple(a, e, f);
+}
+
 } // namespace ns3
